<%@ PAGE LANGUAGE="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.IO" %>
<html>
<head>
<script runat="server">
void Page_Load(object sender, EventArgs e) {
	if (!IsPostBack) {
		datagrid1.DataSource = CreateDataSource();
		datagrid1.DataBind();
	}
}

ICollection CreateDataSource() {
	DirectoryInfo di = new DirectoryInfo(Server.MapPath("."));
	FileInfo[] fi = di.GetFiles();

	DataTable dt = new DataTable();
	DataRow dr;

	dt.Columns.Add(new DataColumn("fileid", typeof(int)));
	dt.Columns.Add(new DataColumn("filename", typeof(String)));
	dt.Columns.Add(new DataColumn("filesize", typeof(long)));
	dt.Columns.Add(new DataColumn("date", typeof(DateTime)));

	for (int i = 0; i < fi.Length; i++) {
		dr = dt.NewRow();
		dr[0] = i;
		dr[1] = fi[i].Name;
		dr[2] = fi[i].Length;
		dr[3] = fi[i].LastWriteTime;
		dt.Rows.Add(dr);
	}

	DataView dv = new DataView(dt);

	return dv;
}

void datagrid1_Edit(object sender, DataGridCommandEventArgs e) {
	datagrid1.EditItemIndex = e.Item.ItemIndex;
	datagrid1.DataSource = CreateDataSource();
	datagrid1.DataBind();
}

void datagrid1_Cancel(object sender, DataGridCommandEventArgs e) {
	datagrid1.EditItemIndex = -1;
	datagrid1.DataSource = CreateDataSource();
	datagrid1.DataBind();
}

void datagrid1_Update(object sender, DataGridCommandEventArgs e) {
	int fileid = (int) datagrid1.DataKeys[e.Item.ItemIndex];
	TextBox filename = (TextBox) e.Item.Cells[0].Controls[0];
	TextBox filesize = (TextBox) e.Item.Cells[1].Controls[0];
	TextBox date     = (TextBox) e.Item.Cells[2].Controls[0];

	Message.Text = filename.Text;

	datagrid1.EditItemIndex = -1;
	datagrid1.DataSource = CreateDataSource();
	datagrid1.DataBind();
}

void datagrid1_Delete(object sender, DataGridCommandEventArgs e) {
}

void datagrid1_Select(object sender, EventArgs e) {
//	datagrid1.SelectedIndex = e.Item.ItemIndex;
	datagrid1.DataSource = CreateDataSource();
	datagrid1.DataBind();
}
</script>
</head>
<body>
<form runat="server">
	<div align="center">
	<asp:DataGrid id="datagrid1"
		AutoGenerateColumns="false"
		DataKeyField="fileid"
		OnCancelCommand="datagrid1_Cancel"
		OnDeleteCommand="datagrid1_Delete"
		OnEditCommand="datagrid1_Edit"
		OnSelectedIndexChanged="datagrid1_Select"
		OnUpdateCommand="datagrid1_Update"
		Width="90%"
		runat="server">
		<SelectedItemStyle BackColor="gray" />
		<Columns>
		<asp:BoundColumn HeaderText="t@C" DataField="filename" />
		<asp:BoundColumn HeaderText="TCY" DataField="filesize" />
		<asp:BoundColumn HeaderText="XV" DataField="date" />
		<asp:EditCommandColumn
			ButtonType="LinkButton" 
			CancelText="LZ"
			EditText="ҏW"
			UpdateText="XV" />
		<asp:ButtonColumn ButtonType="LinkButton" CommandName="Delete" Text="폜" />
		<asp:ButtonColumn ButtonType="LinkButton" CommandName="Select" Text="I" />
		</Columns>
	</asp:DataGrid>
	<asp:Label id="Message" runat="server" />
	</div>
</form>
</body>
</html>
